% Auteur : Alexandre Boyer (INSA de Toulouse)
% TP n1 - partie 1 - Dcomposition en srie de Fourier d'un signal priodique chantillonne
% Script n1 : dveloppement en srie de Fourier d'un signal priodique quelconque
% 1. trac de la fonction temporelle  dcomposer 
% 2. affichage des valeurs de coefficients de Fourier du rang 0 jusqu' un rang max  N
% dfini par l'utilisateur
% 3. trac de l'volution du module des coefficients de Fourier en fonction du rang.
%
% Appuyez sur l'icone Run (ou raccource claiver F5) pour excuter ce script.

clear all;

%dfinition des paramtres d'entre (base de temps, priode fondamentale, pas d'chantillonnage).
%A rgler par l'utilisateur
tmin = ; %borne temporelle min. du signal
tmax = ; %borne temporelle min. du signal 
T0 = ; %priode du signal  analyser
F0 = ; %frquence fondamentale du signal  analyser
dt = ; %pas de discrtisation temporel
Fmax = ; % frquence du rang max respectant le critre de Nyquist
Nmax = ; %rang max respectant le critre de Nyquist
t = tmin:dt:(tmax-dt); %vecteur contenant la base de temps du signal  analyser (utile uniquement
 %pour l'affichage graphique du signal temporel)

 %nb de points des vecteurs stockant le signal temporel et les valeurs prises par le signal  analyser. 
sz = size(t);
Nt = sz(1,2);

% La fonction remplit un vecteur MyFonction_f_t contenant les valeurs prises par une fonction mathmatique f(t) ( dfinir par l'utilisateur)
% aux instants donns par le vecteur time.
% Le vecteur time a une taille 1*Npts. Il est construit uniquement sur une priode fondamentale de la fonction f(t). 
% Le vecteur de sortie MyFonction a aussi une taille 1* Npts.
% La variable d'entre Ampl permet d'ajuster l'amplitude de la fonction. 
function MyFonction_f_t = CreateFonctionPeriodique_ft(Ampl,time)
  Npts = size(time)(1,2);  
  MyFonction_f_t = zeros(1,Npts);
  MyFonction_f_t(1,1:Npts/2) = Ampl*ones(1,1:Npts/2);
  MyFonction_f_t(1,Npts/2+1:Npts) = -Ampl*ones(1,1:Npts/2);
endfunction

%Calcul des coefficients de Fourier calculs du rang 0 jusqu'au rang N. Le vecteur
%rang stocke les valeurs de rang pour lesquels on effectue la dcomposition en srie de Fourier.
N = ;
rang = 0:1:N;

%dfinition du vecteur stockant la fonction test f(t) :  dfinir par l'utilisateur
A = 1;
fonction_temp = CreateFonctionPeriodique_ft(A,t);

% trac de la fonction f
figure(1);
plot(t,f_t,'r');
title('Trac de la fonction');
xlabel('Temps (s)');
ylabel('Amplitude');
grid;

%calcul des coefficients de Fourier (seulement les rangs compris entre 0 et N). 
%Le nombre de coefficients  calculer = 1+ N car il faut compter la composante continue).
%Ils sont stocks dans le vecteur Fourier. 
Fourier = zeros(,);
i = sqrt(-1); %Nombre imaginaire. Utile au cas o on aurait cras la variable i.
j = sqrt(-1); %Nombre imaginaire. Utile au cas o on aurait cras la variable j.
Kt = dt/(tmax-tmin);
for k = 1:N+1
  %boucle de calcul  complter
  
  Fourier(k) = ;
end,


%affichage des valeurs des N+1 premiers coefficients de Fourier
Message = sprintf('Valeur des %i premiers coefficients de Fourier :\n',N+1);
disp(Message);
for k = 1:N+1
  Message = sprintf('C%i = %f+k*%f \n',k-1,real(Fourier(k)),imag(Fourier(k)));
  disp(Message);
end,

%trac des modules des coefficients de Fourier en fonction de leur rang
figure(2);
%plot(rang,abs(Fourier),'r'); %pour un affichage sous la forme d'une ligne continue
%semilogy(rang,abs(Fourier),'r'); %pour un affichage sous la forme d'une ligne continue, avec chelle log sur Y
stem(rang,abs(Fourier),'r'); %pour un affichage sous la forme de points
title('Evolution des coefficents de Fourier en fonction du rang');
xlabel('Rang');
ylabel('Amplitude');
grid;